--app.lua

app = {}

app.setItemUnlocked = function(item)
	rewardVar = "reward_"..tostring(item)
    scores:getScore(rewardVar):setValue(1)
end

app.getCurrentLevel = function()
    return scores:getScore("currentLevel"):getValue()
end

app.setCurrentLevel = function(currentLevel)
	if (currentLevel > app.getCurrentLevel()) then
    	scores:getScore("currentLevel"):setValue(currentLevel)
	end
end

app.setLevelScore = function(level,score)
	if (score > app.getLevelScore(level)) then
	    scores:getScore("level"..tostring(level)):setValue(score)
	end
end

app.getLevelScore = function(level)
	scoreVar = "level"..tostring(level)
    return scores:getScore(scoreVar):getValue()
end

app.getTotalScore = function()
	currLevelVar = scores:getScore("currentLevel"):getValue() + 1
	totalPoints = 0
	for level = 1,currLevelVar do
    	scoreVar = "level"..tostring(level)
        totalPoints = totalPoints + scores:getScore(scoreVar):getValue()
    end
    return totalPoints
end

app.isItemUnlocked = function(item)
    rewardVar = "reward_"..tostring(item)
    return (scores:getScore(rewardVar):getValue() == 1)
end

app.isLevelUnlocked = function(level)
	return (level <= app.getCurrentLevel())
end

app.setGateUnlocked = function(gate)
	gateVar = "gate"..tostring(gate)
    scores:getScore(gateVar):setValue(1)
end

app.isGateUnlocked = function(gate)
    gateVar = "reward"..tostring(gate)
    return (scores:getScore(gateVar):getValue() == 1)
end

app.getLevelTime = function(level,star)
    levelVar = "level"..tostring(level)
    starVar = "time_star"..tostring(star)
    return (app.getConfigData("levels",tostring(levelVar),tostring(starVar)))
end

app.getConfigData = function(tbl,row,column)
    idx = ConfigTables.Index:new(tbl,row,column)
    r,val = config:get(idx,v)
    return val
end

app.resetLevel = function()
    scores:getScore("currentLevel"):setValue(1)
end

app.resetStars = function(level)
	scores:getScore("level"..tostring(level)):setValue(0)
end

app.isThisTheLevel = function(level)
	return (scores:getScore("currentLevel"):getValue() == level)
end

app.starsRequired = function(stars)
	return (app.getTotalScore() >= stars)
end

app.increaseCountdown = function(value)
    score = scores:getScore("countdown")
    score:setValue(score:getValue () + value)
end

app.setCountdown = function(value)
    score = scores:getScore("countdown")
    score:setValue(value)
end

app.getCountdown = function()
    return scores:getScore("countdown"):getValue()
end

app.getEatingLevel = function()
    print ("#### in getEatingLevel")
    value = app.getMiniGameLevel("eating")
    print("##### getEatingLevel",value)
    return value
end

app.setEatingLevel = function(level)
    print("##### setEatingLevel",tostring(level))
    app.setMiniGameLevel("eating",level)
end

app.getMiniGameLevel = function(minigame)
    print ("#### in getMiniGameLevel")
    levelVar = minigame .. "Level"
    print ("#### ",levelVar)
    val = scores:getScore(levelVar):getValue()
    print ("####### value is: ",val)
    return val
end

app.setMiniGameLevel = function(minigame,level)
    print ("#### in setMiniGameLevel")
    levelVar = minigame .. "Level"
    print ("#### ",levelVar)
    scores:getScore(levelVar):setValue(level)
end
----------
app.isExpertLevelCatchingUnlocked = function(level)
    return (level <= app.getCurrentExpertLevelCatching())
end

app.isThisTheExpertLevelCatching = function(level)
    return (scores:getScore("currentExpertLevelCatching"):getValue() == level)
end

app.getCurrentExpertLevelCatching = function()
    return scores:getScore("currentExpertLevelCatching"):getValue()
end

app.setCurrentExpertLevelCatching = function(currentLevel)
    if (currentLevel > app.getCurrentExpertLevelCatching()) then
        scores:getScore("currentExpertLevelCatching"):setValue(currentLevel)
    end
end

app.setExpertLevelCatchingScore = function(level,score)
    if (score > app.getExpertLevelCatchingScore(level)) then
        scores:getScore("levelExpertCatching"..tostring(level)):setValue(score)
    end
end

app.getExpertLevelCatchingScore = function(level)
    scoreVar = "levelExpertCatching"..tostring(level)
    return scores:getScore(scoreVar):getValue()
end

app.resetExpertLevelCatching = function()
    scores:getScore("currentExpertLevelCatching"):setValue(5)
end

app.resetExpertCatchingStars = function(level)
    scores:getScore("levelExpertCatching"..tostring(level)):setValue(0)
end
--------
app.isExpertLevelRiverUnlocked = function(level)
    return (level <= app.getCurrentExpertLevelRiver())
end

app.isThisTheExpertLevelRiver = function(level)
    return (scores:getScore("currentExpertLevelRiver"):getValue() == level)
end

app.getCurrentExpertLevelRiver = function()
    return scores:getScore("currentExpertLevelRiver"):getValue()
end

app.setCurrentExpertLevelRiver = function(currentLevel)
    if (currentLevel > app.getCurrentExpertLevelRiver()) then
        scores:getScore("currentExpertLevelRiver"):setValue(currentLevel)
    end
end

app.setExpertLevelRiverScore = function(level,score)
    if (score > app.getExpertLevelRiverScore(level)) then
        scores:getScore("levelExpertRiver"..tostring(level)):setValue(score)
    end
end

app.getExpertLevelRiverScore = function(level)
    scoreVar = "levelExpertRiver"..tostring(level)
    return scores:getScore(scoreVar):getValue()
end

app.resetExpertLevelRiver = function()
    scores:getScore("currentExpertLevelRiver"):setValue(25)
end

app.resetExpertRiverStars = function(level)
    scores:getScore("levelExpertRiver"..tostring(level)):setValue(0)
end
--------
app.isExpertLevelEatingUnlocked = function(level)
    return (level <= app.getCurrentExpertLevelEating())
end

app.isThisTheExpertLevelEating = function(level)
    return (scores:getScore("currentExpertLevelEating"):getValue() == level)
end

app.getCurrentExpertLevelEating = function()
    return scores:getScore("currentExpertLevelEating"):getValue()
end

app.setCurrentExpertLevelEating = function(currentLevel)
    if (currentLevel > app.getCurrentExpertLevelEating()) then
        scores:getScore("currentExpertLevelEating"):setValue(currentLevel)
    end
end

app.setExpertLevelEatingScore = function(level,score)
    if (score > app.getExpertLevelEatingScore(level)) then
        scores:getScore("levelExpertEating"..tostring(level)):setValue(score)
    end
end

app.getExpertLevelEatingScore = function(level)
    scoreVar = "levelExpertEating"..tostring(level)
    return scores:getScore(scoreVar):getValue()
end

app.resetExpertLevelEating = function()
    scores:getScore("currentExpertLevelEating"):setValue(2)
end

app.resetExpertEatingStars = function(level)
    scores:getScore("levelExpertEating"..tostring(level)):setValue(0)
end

-- for restore button
srvc = {}

srvc.isAndroid = function()
    print("srvc.isAndroid "..tostring(isAndroid).."")
    return (isAndroid == 1)
end

---------------------------------------------------------

--currentLevel(5) AND (not app.isGateUnlocked(1)) AND (getTotalScore() > 11)
--do! setGateUnlcoked